/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package reconhecimento;

import java.awt.event.KeyEvent;
import java.util.Scanner;
import org.bytedeco.javacpp.opencv_core.Mat;
import org.bytedeco.javacpp.opencv_core.Rect;
import org.bytedeco.javacpp.opencv_core.RectVector;
import org.bytedeco.javacpp.opencv_core.Scalar;
import org.bytedeco.javacpp.opencv_core.Size;
import static org.bytedeco.javacpp.opencv_imgcodecs.imwrite;
import org.bytedeco.javacpp.opencv_imgproc;
import static org.bytedeco.javacpp.opencv_imgproc.COLOR_BGRA2GRAY;
import static org.bytedeco.javacpp.opencv_imgproc.cvtColor;
import static org.bytedeco.javacpp.opencv_imgproc.rectangle;
import static org.bytedeco.javacpp.opencv_imgproc.resize;
import org.bytedeco.javacpp.opencv_objdetect.CascadeClassifier;
import org.bytedeco.javacv.CanvasFrame;
import org.bytedeco.javacv.Frame;
import org.bytedeco.javacv.FrameGrabber;
import org.bytedeco.javacv.OpenCVFrameConverter;
import org.bytedeco.javacv.OpenCVFrameGrabber;

/**
 *
 * @author Leonel Ceolin Farias
 */
public class Captura {
    public static void main(String args[]) throws FrameGrabber.Exception, InterruptedException{
        KeyEvent tecla = null; 
        OpenCVFrameConverter.ToMat converteMat= new OpenCVFrameConverter.ToMat();//realiza a conversão da imagem em uma matriz
        OpenCVFrameGrabber camera = new OpenCVFrameGrabber(0);
        camera.start(); //inicia a captura da webcam 
        
        CascadeClassifier detectorFace = new CascadeClassifier("src\\recursos\\haarcascade-frontalface-alt.xml"); //linha responsável pela identificação das faces
        
        
        CanvasFrame cFrame = new CanvasFrame("Captura", CanvasFrame.getDefaultGamma()/camera.getGamma());
        Frame frameCapturado = null;
        
        Mat imagemColorida = new Mat(); //através da imagem colorida que será realizada a detecção das faces
        Mat imagemCinza = new Mat();
        
        int numeroAmostras = 25; //numero necessário de imagens de cada pessoa para que o algoritmo funcione da melhor forma
        int amostra = 1; //contador para controlar o numero de imagens
        System.out.println("Digite seu id: ");
        Scanner cadastro = new Scanner(System.in);//aguarda a entrada do usuário
        int idPessoa = cadastro.nextInt();
        
        while((frameCapturado = camera.grab()) != null){
            imagemColorida = converteMat.convert(frameCapturado); //está colocando o frameCapturado dentro da imagem colorida
            cvtColor(imagemColorida, imagemCinza, COLOR_BGRA2GRAY);
            RectVector facesDetectadas = new RectVector();
            detectorFace.detectMultiScale(imagemCinza, facesDetectadas, 1.1, 1, 0, new Size(150,150), new Size(500,500)); 
            
            if(tecla == null){
                tecla = cFrame.waitKey(5);
            }
            for(int i=0; i<facesDetectadas.size(); i++){
                Rect dadosFace = facesDetectadas.get(0);
                rectangle(imagemColorida, dadosFace, new Scalar(0, 0, 255, 0));
                
                Mat faceCapturada = new Mat(imagemCinza, dadosFace); //faceCapturada recebe somente os dados presentes dentro do quadrado da detecção
                resize(faceCapturada, faceCapturada, new Size(160,160));//redimensiona as imagens para ajudar no processo de reconhecimento e evitar erros
                if(tecla == null){
                    tecla = cFrame.waitKey(5);
                }
                if(tecla != null){
                    if(tecla.getKeyChar()=='q'){
                        if(amostra <= numeroAmostras){
                            imwrite("src\\fotos\\pessoa." + idPessoa + "." + amostra + ".jpeg", faceCapturada);
                            System.out.println("foto " + amostra + " capturada \n");
                            amostra++;
                        }
                    }
                    tecla = null;
                }
            }
            
            if(tecla == null){
                tecla = cFrame.waitKey(20);
            } 
            if(cFrame.isVisible()){
                cFrame.showImage(frameCapturado);
            }
            if(amostra > numeroAmostras){
                break;
            }
        }
        cFrame.dispose();
        camera.stop();
    }
}
