/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package reconhecimento;

import java.io.IOException;
import java.sql.SQLException;
import java.util.Date;
import java.util.Set;
import org.bytedeco.javacpp.DoublePointer;
import org.bytedeco.javacpp.IntPointer;
import static org.bytedeco.javacpp.opencv_core.FONT_HERSHEY_PLAIN;
import org.bytedeco.javacpp.opencv_core.Mat;
import org.bytedeco.javacpp.opencv_core.Point;
import org.bytedeco.javacpp.opencv_core.Rect;
import org.bytedeco.javacpp.opencv_core.RectVector;
import org.bytedeco.javacpp.opencv_core.Scalar;
import org.bytedeco.javacpp.opencv_core.Size;
import org.bytedeco.javacpp.opencv_face.FaceRecognizer;
import static org.bytedeco.javacpp.opencv_face.createLBPHFaceRecognizer;
import static org.bytedeco.javacpp.opencv_imgcodecs.imwrite;
import static org.bytedeco.javacpp.opencv_imgproc.COLOR_BGRA2GRAY;
import static org.bytedeco.javacpp.opencv_imgproc.cvtColor;
import static org.bytedeco.javacpp.opencv_imgproc.putText;
import static org.bytedeco.javacpp.opencv_imgproc.rectangle;
import static org.bytedeco.javacpp.opencv_imgproc.resize;
import org.bytedeco.javacpp.opencv_objdetect.CascadeClassifier;
import org.bytedeco.javacv.CanvasFrame;
import org.bytedeco.javacv.Frame;
import org.bytedeco.javacv.FrameGrabber;
import org.bytedeco.javacv.OpenCVFrameConverter;
import org.bytedeco.javacv.OpenCVFrameGrabber;

/**
 *
 * @author Leonel Ceolin Farias
 */
public class Reconhecimento {

    public static void rec() throws FrameGrabber.Exception, InterruptedException, SQLException, IOException {
        OpenCVFrameConverter.ToMat converteMat = new OpenCVFrameConverter.ToMat();//realiza a conversão da imagem em uma matriz
        OpenCVFrameGrabber camera = new OpenCVFrameGrabber(0);
        camera.start(); //inicia a captura da webcam        
        String[] pessoas = {"", "Angela", "Leonel"};

        String[] logReconhecidos = new String[20];
        String[] reconhecidos = new String[20];
        String[] desconhecidos = new String[20];
        String[] logDesconhecidos = new String[20];
        int contReconhecidos = 1;
        int contDesconhecidos = 1;
        int cont = 100;

        CascadeClassifier detectorFace = new CascadeClassifier("src\\recursos\\haarcascade-frontalface-alt.xml"); //linha responsável pela identificação das faces

        /*FaceRecognizer reconhecedor = createEigenFaceRecognizer(); 
        reconhecedor.load("src\\recursos\\classificadorEigenFaces.yml");
        //reconhecedor.setThreshold(7000); //se o valor do threshold for menor do que o identificado na imagem
        //o algoritmo reconhece a pessoa, caso seja maior, ele não reconhece*/
        FaceRecognizer reconhecedor = createLBPHFaceRecognizer();
        reconhecedor.load("src\\recursos\\classificadorLBPH.yml");
        reconhecedor.setThreshold(10); 

        CanvasFrame cFrame = new CanvasFrame("Reconhecimento", CanvasFrame.getDefaultGamma() / camera.getGamma());
        Frame frameCapturado = null;
        Mat imagemColorida = new Mat(); //através da imagem colorida que será realizada a detecção das faces
        Mat imagemCinza = new Mat();

        while ((frameCapturado = camera.grab()) != null) {
            imagemColorida = converteMat.convert(frameCapturado); //está colocando o frameCapturado dentro da imagem colorida
            cvtColor(imagemColorida, imagemCinza, COLOR_BGRA2GRAY); //converte da colorida para escala de cinza
            RectVector facesDetectadas = new RectVector();//armazena todas a faces detectadas passando na webcam
            detectorFace.detectMultiScale(imagemCinza, facesDetectadas, 1.1, 2, 0, new Size(100, 100), new Size(350, 350)); //detecção em escala de cinza

            for (int i = 0; i < facesDetectadas.size(); i++) { //entra no laço caso tenha reconhecido uma face
                Rect dadosFace = facesDetectadas.get(i); //dadosFace recebe os dados da imagem que foi detectada, dentro do quadrado de detecção
                rectangle(imagemColorida, dadosFace, new Scalar(0, 0, 255, 0)); //desenha o retangulo

                Mat faceCapturada = new Mat(imagemCinza, dadosFace); //faceCapturada recebe somente os dados presentes dentro do quadrado da detecção
                resize(faceCapturada, faceCapturada, new Size(160, 160));//redimensiona as imagens para ajudar no processo de reconhecimento e evitar erros

                IntPointer rotulo = new IntPointer(1); //para identificar qual é rotulo da imagem, se é a pessoa 1 ou 2
                DoublePointer confianca = new DoublePointer(1);
                reconhecedor.predict(faceCapturada, rotulo, confianca); //quando executar o predict irá passar o rotulo(1 ou 2) e a confiança
                String nome = null;

                int predicao = rotulo.get(0); //resposta final, na posição 0(zero) se encontra o resultado, a qual classe a imagem pertence
                Date data = new Date();

                if (predicao == -1) { //nao conseguiu identificar a pessoa
                    if (cont % 100 == 0) {
                        nome = "Desconhecido";
                        imwrite("src\\desconhecidos\\" + nome + "." + contDesconhecidos + ".jpg", faceCapturada);
                        logDesconhecidos[contDesconhecidos] = nome + "-" +contDesconhecidos + "-" + data.toString(); //log desconhecido
                        desconhecidos[contDesconhecidos] = nome + "." + contDesconhecidos + ".jpg"; //salvando imagem no vetor de desconhecidos

                        //System.out.println("LOG - " + logDesconhecidos[contDesconhecidos]);
                        //System.out.println(desconhecidos[contDesconhecidos]);

                        EnviarBD.send(desconhecidos[contDesconhecidos]);
                        EnviarBD.sendLog(logDesconhecidos[contDesconhecidos]);
                        contDesconhecidos++;
                    }
                    cont++;
                } else {
                    if (cont % 100 == 0) {
                        //salva na variável nome, o nome da pessoa que foi reconhecida e a data que esteve no local
                        nome = pessoas[predicao];// + " - " + confianca.get(0);
                        //+ " - " + confianca.get(0) 
                        //imwrite("src\\desconhecidos\\" + nome + contReconhecidos + ".jpg", faceCapturada);
                        logReconhecidos[contReconhecidos] = nome + '-' + data.toString();
                        //reconhecidos[contReconhecidos] = nome + '-' + data.toString();
                        System.out.println("LOG - " + logReconhecidos[contReconhecidos]);
                        //EnviarBD.send(reconhecidos[contReconhecidos]);
                        EnviarBD.sendLog(logReconhecidos[contReconhecidos]);
                        contReconhecidos++;
                    }
                    
                    cont++;
                }

                int x = Math.max(dadosFace.tl().x() - 10, 0);
                int y = Math.max(dadosFace.tl().y() - 10, 0);
                putText(imagemColorida, nome, new Point(x, y), FONT_HERSHEY_PLAIN, 1.4, new Scalar(0, 255, 0, 0));
            }
            if (cFrame.isVisible()) {
                cFrame.showImage(frameCapturado);
            }
        }
        cFrame.dispose();
        camera.stop();
    }
}
